//+------------------------------------------------------------------+
//| ZigZag History Arrows                                            |
//|                                                                  |
//| Copyright  2014 / airquest@hotmail.com                          |
//|                                                                  |
//| http://smart-trading.world-record.ch                             |
//+------------------------------------------------------------------+


   #property copyright   "Copyright  2014 // airquest // smart-trading.world-record.ch"
   #property link        "http://smart-trading.world-record.ch"
   #property description "ZigZag History Arrows"
   #property version     "1.00"


//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_color3 Gray
#property indicator_color4 Gray

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

extern bool    ShowSignals               = True;
extern bool    ShowChannel               = False;
//------------------------------------------------------------------
extern string  NoteZZ                    = "========= ZigZag =========";
extern int     ZZDepth                   = 12;
extern int     ZZDeviation               = 5;
//+------------------------------------------------------------------
extern string  NoteArrows                = "================== Arrows ==================";
extern double  ArrowsDisplacement        = 0.5;
extern int     ArrowsUpCode              = 233;
extern int     ArrowsDnCode              = 234;
extern string  LinkForArrowsCodes        = "http://docs.mql4.com/constants/objectconstants/wingdings";
//+------------------------------------------------------------------
extern string  NoteAlerts                = "================== Alerts ==================";
extern bool    AlertsOn                  = True;
extern bool    AlertsOnCurrent           = True;
extern bool    AlertsEmail               = False;
extern bool    AlertsPush                = False;
extern bool    AlertsSound               = False;
extern string  Sound                     = "alert2.wav";
//+------------------------------------------------------------------
extern string  NoteMessages              = "================== Messages ==================";
extern string  MessageUp                 = "ZigZag Buy";
extern string  MessageDn                 = "ZigZag Sell";

//------------------------------------------------------------------

double ArrowsBuy[];
double ArrowsSell[];
double Hi[];
double Lo[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{

//+------------------------------------------------------------------+

   IndicatorBuffers(4);

   SetIndexBuffer(0,ArrowsBuy);     SetIndexStyle(0,DRAW_ARROW);     SetIndexArrow(0,ArrowsUpCode);
   SetIndexBuffer(1,ArrowsSell);    SetIndexStyle(1,DRAW_ARROW);     SetIndexArrow(1,ArrowsDnCode);

   if(!ShowSignals) SetIndexStyle(0,DRAW_NONE);
   if(!ShowSignals) SetIndexStyle(1,DRAW_NONE);

   SetIndexLabel(0,"Buy Signal");
   SetIndexLabel(1,"Sell Signal");

   SetIndexBuffer(2,Hi);   if(!ShowChannel) SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,Lo);   if(!ShowChannel) SetIndexStyle(3,DRAW_NONE);

   for(int i=0; i<4; i++) SetIndexDrawBegin(i,MathMax(ZZDepth,ZZDeviation));

   IndicatorShortName("ZigZag History ("+ZZDepth+","+ZZDeviation+")");

//+------------------------------------------------------------------+

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars = IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   int i,limit = MathMin(Bars-counted_bars,Bars-1);

   double val1=0.0,val2=0.0,lasthigh=0.0,lastlow=0.0;
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

   for(i=limit; i>=0; i--)
   {
      
//+------------------------------------------------------------------+ Gap & Arrows Buffers

      double gap = iATR(NULL,0,20,i);
      
      ArrowsBuy[i]     = EMPTY_VALUE;
      ArrowsSell[i]    = EMPTY_VALUE;

//+------------------------------------------------------------------+ Low ZZ

      val1 = Low[iLowest(NULL,0,MODE_LOW,ZZDepth,i)];
      if(val1 == lastlow) val1 = 0.0;
      else
      {
         lastlow = val1;
         if((Low[i] - val1) > (ZZDeviation * Point)) val1 = 0.0;
      } 
      if (Low[i] == val1) { Lo[i] = val1; ArrowsBuy[i]  = Low[i]  - gap * ArrowsDisplacement; }
      else                  Lo[i] = Lo[i+1];

//+------------------------------------------------------------------+ High ZZ

      val2 = High[iHighest(NULL,0,MODE_HIGH,ZZDepth,i)];
      if(val2 == lasthigh) val2 = 0.0;
      else
      {
         lasthigh = val2;
         if((val2 - High[i]) > (ZZDeviation * Point)) val2 = 0.0;
      } 
      if(High[i] == val2) { Hi[i] = val2; ArrowsSell[i] = High[i] + gap * ArrowsDisplacement; }
      else                  Hi[i] = Hi[i+1];

//+------------------------------------------------------------------+

   }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+ Alerts

   if (AlertsOnCurrent)
   int  whichBar = 0;
   else whichBar = 1;

   if      (ArrowsBuy[whichBar] != EMPTY_VALUE)
   {
      if(AlertsOn) doAlert(whichBar,MessageUp,AlertsEmail,AlertsPush,AlertsSound,Sound);
   }

   else if(ArrowsSell[whichBar] != EMPTY_VALUE)
   {
      if(AlertsOn) doAlert(whichBar,MessageDn,AlertsEmail,AlertsPush,AlertsSound,Sound);
   }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void doAlert(int forBar, string doWhat, bool alertEmail, bool alertPush, bool alertSound, string alert)
{
   static string   previousAlert = "Nothing";
   static datetime previousTime;
   string message;

   if (previousAlert != doWhat && previousTime != Time[forBar])
   {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message = StringConcatenate("ZigZag"," - ",Symbol()," - ",TimeFrameToString(Period())," - ",doWhat," - at:",
                                   TimeToStr(TimeLocal(),TIME_MINUTES));

                            Alert(message);
          if (alertEmail)   SendMail(message,message);
          if (alertPush)    SendNotification(message);
          if (alertSound)   PlaySound(alert);
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf)
   {
      case PERIOD_M1:     tfs = "M1";      break;
      case PERIOD_M5:     tfs = "M5";      break;
      case PERIOD_M15:    tfs = "M15";     break;
      case PERIOD_M30:    tfs = "M30";     break;
      case PERIOD_H1:     tfs = "H1";      break;
      case PERIOD_H4:     tfs = "H4";      break;
      case PERIOD_D1:     tfs = "D1";      break;
      case PERIOD_W1:     tfs = "W1";      break;
      case PERIOD_MN1:    tfs = "MN1";     break;
      default: tfs = "M" + DoubleToStr(tf,0);
   }
   return(tfs);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+